///////////////////////////////////////////////////
//                    toniR                     //
///////////////////////////////////////////////////
//         Code Create by LabCEES 2.0a          //
//              Udg CopyRight 1998              //
//            Joan Cervera 3er Etis             //
///////////////////////////////////////////////////
#include "toniR.h"
#include "ddecom.h"

#define si 1
#define no 0

//- Informacio del sistema en concret
extern Informacio DDEinfo;
extern char *Items[];
extern void put_box(char *);
extern char hora[20];
extern int ActivatSB;

//- System Declaration
Inference_Engine_1 primari;
Inference_Engine_2 secundari;
Inference_Engine_3 diagnostic;
Inference_Engine_4 accions;

//- Extern Functions
void mostrar_valors()
{
	double *p;
	int i;
	
	p=(double *)&DDEinfo;
	for(i=0; i<numItems; i++)
		printf("%s : %f",Items[i], *p++);
}

char *double_a_string(double num)
{
	int dec,sign, i,numdigits=6;
	static char certesa[20];
	
	strcpy(certesa, fcvt(num,numdigits,&dec,&sign));
	if (dec >=0)
	{
		for (i=19; i>dec; i--)
			certesa[i]=certesa[i-1];
		certesa[i]='.';	
	}
	if (dec == 0)
	{
		for(i=19; i>dec; i--) 
			certesa[i]=certesa[i-1];
		certesa[i]='0';
	}
	return (&certesa[0]);
}

//- Systems Implementation
Begin Inference_Engine_1 LcSystem


	//- Facts declaration
	static DATAFACT *PF, Pa1_Pa2, Pc1_Pc2, Pc2, regulador, T1, T1_T7, T7;



	set_opposites(permanent, transitori);
//- Datafact
	Pa1_Pa2.name = 1;
	Pa1_Pa2.type = NUMERICFACT;
	sprintf (Pa1_Pa2.description, "Pa1 - Pa2");
	sprintf (Pa1_Pa2.fact_value.units, "bars");
	Pa1_Pa2.fact_value.inf_limit = -0.25;
	Pa1_Pa2.fact_value.sup_limit = 0.25;
	Pa1_Pa2.fact_value.step_v = 0;
	Pa1_Pa2.fact_value.lowest = 0;
	Pa1_Pa2.fact_value.low = 0.1;
	Pa1_Pa2.fact_value.normal = 0;
	Pa1_Pa2.fact_value.high = 0;
	Pa1_Pa2.fact_value.highest = 0;

//- Datafact
	Pc1_Pc2.name = 2;
	Pc1_Pc2.type = NUMERICFACT;
	sprintf (Pc1_Pc2.description, "Pc1 - Pc2");
	sprintf (Pc1_Pc2.fact_value.units, "bars");
	Pc1_Pc2.fact_value.inf_limit = -0.1;
	Pc1_Pc2.fact_value.sup_limit = 0.4;
	Pc1_Pc2.fact_value.step_v = 0.2;
	Pc1_Pc2.fact_value.lowest = 0;
	Pc1_Pc2.fact_value.low = -0.1;
	Pc1_Pc2.fact_value.normal = 0.2;
	Pc1_Pc2.fact_value.high = 0;
	Pc1_Pc2.fact_value.highest = 0;

//- Datafact
	Pc2.name = 3;
	Pc2.type = NUMERICFACT;
	sprintf (Pc2.description, "Pc2");
	sprintf (Pc2.fact_value.units, "bars");
	Pc2.fact_value.inf_limit = 1;
	Pc2.fact_value.sup_limit = 3;
	Pc2.fact_value.step_v = 0.3;
	Pc2.fact_value.lowest = 0;
	Pc2.fact_value.low = 0;
	Pc2.fact_value.normal = 1.7;
	Pc2.fact_value.high = 0;
	Pc2.fact_value.highest = 0;

//- Datafact
	regulador.name = 7;
	regulador.type = NUMERICFACT;
	sprintf (regulador.description, "Regulador");
	sprintf (regulador.fact_value.units, "%");
	regulador.fact_value.inf_limit = 0;
	regulador.fact_value.sup_limit = 100;
	regulador.fact_value.step_v = 15;
	regulador.fact_value.lowest = 0;
	regulador.fact_value.low = 20;
	regulador.fact_value.normal = 0;
	regulador.fact_value.high = 80;
	regulador.fact_value.highest = 0;

//- Datafact
	T1.name = 6;
	T1.type = NUMERICFACT;
	sprintf (T1.description, "T1");
	sprintf (T1.fact_value.units, "C");
	T1.fact_value.inf_limit = 0;
	T1.fact_value.sup_limit = 90;
	T1.fact_value.step_v = 10;
	T1.fact_value.lowest = 0;
	T1.fact_value.low = 0;
	T1.fact_value.normal = 55;
	T1.fact_value.high = 0;
	T1.fact_value.highest = 0;

//- Datafact
	T1_T7.name = 4;
	T1_T7.type = NUMERICFACT;
	sprintf (T1_T7.description, "T1 - T7");
	sprintf (T1_T7.fact_value.units, "C");
	T1_T7.fact_value.inf_limit = 0;
	T1_T7.fact_value.sup_limit = 20;
	T1_T7.fact_value.step_v = 15;
	T1_T7.fact_value.lowest = 0;
	T1_T7.fact_value.low = 0;
	T1_T7.fact_value.normal = 0;
	T1_T7.fact_value.high = 0;
	T1_T7.fact_value.highest = 15;

//- Datafact
	T7.name = 5;
	T7.type = NUMERICFACT;
	sprintf (T7.description, "T7");
	sprintf (T7.fact_value.units, "C");
	T7.fact_value.inf_limit = 0;
	T7.fact_value.sup_limit = 90;
	T7.fact_value.step_v = 5;
	T7.fact_value.lowest = 0;
	T7.fact_value.low = 35;
	T7.fact_value.normal = 55;
	T7.fact_value.high = 0;
	T7.fact_value.highest = 0;



//- Deduce Facts Values
Pa1_Pa2.assign(DDEinfo.Pa1-mitja_presio_comuna,HIGH);
deduce(&Pa1_Pa2);

Pc1_Pc2.assign(fabs(DDEinfo.Pc1-DDEinfo.Pc2),HIGH);
deduce(&Pc1_Pc2);

Pc2.assign(DDEinfo.Pc2,HIGH);
deduce(&Pc2);

regulador.assign(DDEinfo.regulador,VERYHIGH);
deduce(&regulador);

T1.assign(DDEinfo.T1,VERYHIGH);
deduce(&T1);

T1_T7.assign(fabs(DDEinfo.T1-DDEinfo.T7),VERYHIGH);
deduce(&T1_T7);

T7.assign(DDEinfo.T7,VERYHIGH);
deduce(&T7);



//- Esborrem els coneixements intermitjos i diagnostics
retract_facts_type(INTERMEDIATE);
retract_facts_type(DIAGNOSTIC);

if (visual)
{
	printf("");
	printf("Pa1_Pa2.ups_in_interval = %f", Pa1_Pa2.ups_in_interval());
	printf("Pa1_Pa2.downs_in_interval = %f",Pa1_Pa2.downs_in_interval());
}
Rule 1
/*A partir de la diferncia de presions es mante noms en un cert
interval de temps podem saber si el sitema es estable
o es transitori per culpa d'alguna perturbaci. */

	Description "Primari en estat transitori"
		TraceHere Yes
		Certainty   NORMAL
		Threshold NOTVERYLOW
		IfXor Pa1_Pa2.ups_in_interval() Xor Pa1_Pa2.downs_in_interval()
		Then
			deduce(INTERMEDIATE, transitori)
		Else
			deduce(INTERMEDIATE, permanent)
		EndIfXor
	if (visual)
	{
		printf("");
		printf("Pa1-Pa2 = %f",DDEinfo.Pa1-mitja_presio_comuna);
		printf("Pa1-Pa2 > normal = %f",Pa1_Pa2.greater(Pa1_Pa2.fact_value.normal));
		printf("Pa1-Pa2 > low = %f",Pa1_Pa2.greater(Pa1_Pa2.fact_value.low));
	}
EndRule
Rule 2
/* Amb aquesta regla podrem deduir que les valvules que estan 
al costat de les bombes del grup 1 estan tancades.
*/
	Description "Diferencia de presions Pa1 i Pa2"
		TraceHere Yes
		Certainty	FULL
		Threshold NORMAL
		If DDEinfo.ESTATGRUP11
		Then
			Pa1_Pa2.fact_value.step_v=0.4;
			If Pa1_Pa2.fact_value.greater(Pa1_Pa2.fact_value.normal)
			Then
				deduce(INTERMEDIATE, problemes_VBPrp);
				deduce(DIAGNOSTIC, VOg1b2_tancada);
				deduce(DIAGNOSTIC, VIg1b2_tancada);
			EndIf
		Else
			Pa1_Pa2.fact_value.step_v=0.2;
			If Pa1_Pa2.greater(Pa1_Pa2.fact_value.low)
			Then	
				deduce(INTERMEDIATE, problemes_VBPrp);
				deduce(DIAGNOSTIC, VOg1b1_tancada);
				deduce(DIAGNOSTIC, VIg1b1_tancada);
			EndIf
		EndIf
	if (visual)
	{
		printf("");
		printf("Pc1-Pc2 = %f",mitja_presio_comuna-DDEinfo.Pc2);
		printf("Pc1-Pc2 = normal  %f",Pc1_Pc2.fact_value.equal(Pc1_Pc2.fact_value.normal));
	}

EndRule
Rule 3
/* Amb aquesta regla podrem deduir que potser alguna de les vlvules
	VOpi o VIpi estan tancades
*/

	Description "Diferncia de presions Pc1 i Pc2"
	TraceHere Yes
	Certainty 	VERYHIGH
	Threshold NORMAL
	If DDEinfo.regulador/100
	Then
		If Pc1_Pc2.fact_value.greater(Pc1_Pc2.fact_value.low)
		Then
			deduce(DIAGNOSTIC, VOpi_tancada);
			deduce(DIAGNOSTIC, VIpi_tancada)
		EndIf
	Else 
		If Pc1_Pc2.fact_value.greater(Pc1_Pc2.fact_value.normal)
		Then
			deduce(DIAGNOSTIC, VOpi_tancada);
			deduce(DIAGNOSTIC, VIpi_tancada);
		EndIf
	EndIf

	if (visual)
	{
		printf("");
		printf("Pc2  = %f",DDEinfo.Pc2);
		printf("Pc2 > normal  %f",Pc1_Pc2.fact_value.greater(Pc2.fact_value.normal));
	}

EndRule
Rule 4
/* Amb aquesta regla podrem deduir que les vlvules que stan
	a l'entrada i sortida del regulador estan tancades.
*/
	Description "VOrp o VIrp tancades"
	TraceHere Yes
	Certainty VERYHIGH
	Threshold NORMAL
	If Pc2.fact_value.greater(Pc2.fact_value.normal)
	Then
		If DDEinfo.regulador/100 And Pc2.fact_value.greater(Pc2.fact_value.normal)
		Then
			deduce(DIAGNOSTIC, VOrp_tancada);
			deduce(DIAGNOSTIC, VIrp_tancada);
		Else
			deduce(DIAGNOSTIC, VOrp_tancada)
		EndIf
	EndIf

	if (visual)
	{
		printf("tancament_regulador =%f", 1-DDEinfo.regulador/100);
		printf("Regim normal T1 > 55 =%f", T1.fact_value.greater(T1.fact_value.normal));
		printf("T1 =? T7 = %f",T1_T7.fact_value.equal(T1_T7.fact_value.lowest));
	}

EndRule
Rule 5
/* Amb aquesta regla podrem deduir el bon funcionament de l'obertura
	de la vlvula VBPrp.
*/
	Description "VBPrp tancada"
	TraceHere Yes
	Certainty VERYHIGH
	Threshold NOTVERYHIGH
	IfAny (PF) PF->result.n==problemes_VBPrp.n
		And (1-DDEinfo.regulador/100)
	Then
		If T1.fact_value.greater(T1.fact_value.normal) And T1_T7.fact_value.equal(T1_T7.fact_value.lowest)
		Then
			deduce(DIAGNOSTIC, VBPrp_tancada);
			retract_fact(VOg1b2_tancada);
			retract_fact(VIg1b2_tancada);
			retract_fact(VOg1b1_tancada);
			retract_fact(VIg1b1_tancada)
		EndIf
	EndIfAny
	if (visual)
	{
		ForAll(PF)
			if (PF->result.n == VBPrp_tancada.n)
				printf("certesa VBPrp_tancada=%f",PF->fact_certainty);
		EndForAll

		printf("");
		printf("T7 = %f",DDEinfo.T7);
		printf("T7 > %f = %f",T7.fact_value.normal,T7.greater(T7.fact_value.normal));
		printf("T7 < %f = %f",T7.fact_value.low,T7.lower(T7.fact_value.low));
	}	

EndRule
Rule 6
/*Amb aquesta regla podrem deduir el bon funcionament de l'obertura 
	de la vlvula automtica.
*/
	Description "Mal funcionament del regulador"
	TraceHere Yes
	Certainty VERYHIGH
	Threshold NOTVERYHIGH
	If T7.fact_value.greater(T7.fact_value.normal) And
		regulador.fact_value.greater(regulador.fact_value.low)
	Then
		deduce(DIAGNOSTIC,problemes_regulador)
	EndIf
 
EndRule
Rule 7
/* Amb aquesta regla podrem deduir el bon funcionament de l'obertura 
	de la vlvula automtica.
*/
	Description "Mal funcionament del regulador"
	TraceHere Yes
	Certainty VERYHIGH
	Threshold NOTVERYHIGH
	If T7.fact_value.lower(T7.fact_value.low) And regulador.fact_value.lower(regulador.fact_value.high)
	Then 
		deduce(DIAGNOSTIC,problemes_regulador)
	EndIf
EndRule

semantic_integrity();


EndSystem
//- Systems Implementation
Begin Inference_Engine_2 LcSystem


	//- Facts declaration
	static DATAFACT *PF, Pe1_Pe2;



	set_opposites(permanent, transitori);
//- Datafact
	Pe1_Pe2.name = 8;
	Pe1_Pe2.type = NUMERICFACT;
	sprintf (Pe1_Pe2.description, "Pe1 - Pe2");
	sprintf (Pe1_Pe2.fact_value.units, "bars");
	Pe1_Pe2.fact_value.inf_limit = 0;
	Pe1_Pe2.fact_value.sup_limit = 1.3;
	Pe1_Pe2.fact_value.step_v = 1.2;
	Pe1_Pe2.fact_value.lowest = 0;
	Pe1_Pe2.fact_value.low = 0;
	Pe1_Pe2.fact_value.normal = 0.6;
	Pe1_Pe2.fact_value.high = 0;
	Pe1_Pe2.fact_value.highest = 0;


//- Esborrem els coneixements intermitjos i diagnostics
retract_facts_type(INTERMEDIATE);
retract_facts_type(DIAGNOSTIC);

if (visual)
{
	printf("");
	printf("Pe1_Pe2.ups_in_interval = %f",Pe1_Pe2.ups_in_interval());
	printf("Pe1_Pe2.downs_in_interval = %f",Pe1_Pe2.downs_in_interval());
}

Rule 1
/* Apartir de que la diferncia de presions es mante noms en un cert
interval de temps podem saber si el sistema es estable 
o es transitori per culpa d'alguna perturbaci.
*/
	Description "Secundari en estat transitori"
	TraceHere Yes
	Certainty NORMAL
	Threshold NORMAL
	IfXor Pe1_Pe2.ups_in_interval() Xor Pe1_Pe2.downs_in_interval()
	Then 
		deduce(INTERMEDIATE, transitori)
	Else 
		deduce(INTERMEDIATE, permanent)
	EndIfXor
	if (visual)
	{
		printf("");
		printf("Pe1-Pe2 = %f",fabs(DDEinfo.Pe1-DDEinfo.Pe2));
		printf("Pe1-Pe2 = normal = %f",Pe1_Pe2.fact_value.greater(Pe1_Pe2.fact_value.normal));
	}

EndRule
Rule 2
/* Amb  aquesta regla podrem deduir que potser alguna de les valvules que 
	estan al costat de les bombes del grup 1 estan tancades.
*/
	Description "Diferncia de presions Pe1 i Pe2"
	TraceHere Yes
	Certainty VERYHIGH
	Threshold NOTVERYLOW
	If Pe1_Pe2.greater(Pe1_Pe2.fact_value.normal)	
	Then
		deduce(DIAGNOSTIC, VOsi_tancada);
		deduce(DIAGNOSTIC, VIsi_tancada);
	EndIf
EndRuleRule 1
EndRule



semantic_integrity();


EndSystem
//- Systems Implementation
Begin Inference_Engine_3 LcSystem


	//- Facts declaration
	static DATAFACT *PF;



	set_opposites(permanent, transitori);

Rule 1
/*Amb aquesta regla si el sistema es estable demanem els diagnostic
	que ha deduit el primari.
*/
	Description "Deduccions del primari i secundari correctes"
	TraceHere Yes
	Certainty FULL
	Threshold LOW
	IfAny (PF) PF->result.n == permanent.n And PF->fact_certainty
	Then
		ask_review_deduce(primari, DIAGNOSTIC);
		ask_review_deduce(secundari, DIAGNOSTIC)
	EndIfAny
EndRule


EndSystem
//- Systems Implementation
Begin Inference_Engine_4 LcSystem


	//- Facts declaration
	static DATAFACT *PF;
	//- Local Var Declaration
	int hi_ha_perill;



	set_opposites(permanent, transitori);

// - System Local Vars
hi_ha_perill=0;

//- Esborrem tots els coneixements
retract_all_facts();

//- Establim el valor de prestige i necessity
set_prestige(diagnostic.name, FULL);
set_necessity(diagnostic.name, NUL);

//- Demanem les deduccions DIAGNOSTIC al inf_eng diagnostic
ask_review_deduce(diagnostic, DIAGNOSTIC);

Rule 1
/*Si les deduccions de tipus DIAGNOSTIC son fora creibles llavors
	les dedueixo amb la MATEIXA CERTESA com a tipus ACTION.
*/
	Description "Pas diagnostic a action"
	TraceHere Yes
	Certainty FULL
	ForAll(PF)
		if ((PF->type == DIAGNOSTIC) && (PF->fact_certainty >= VERYLOW))
		{
			If PF->fact_certainty
			Then
				deduce(PF, ACTION)
			EndIf
		}
	EndForAll
EndRule


ForAll(PF)
	if (PF->type == ACTION)
	{
		hi_ha_perill=si;
		if (PF->result.n == problemes_regulador.n)
		{
			Hotdde("REGULADOR",double_a_string(PF->fact_certainty));
		}
		else
		if (PF->result.n == VOg1b1_tancada.n)
		{
			Hotdde("VOg1b1",double_a_string(PF->fact_certainty));
		}
		else
		if (PF->result.n == VOg1b2_tancada.n)
		{
			Hotdde("VOg1b2",double_a_string(PF->fact_certainty));
		}	
		else
		if (PF->result.n == VIg1b2_tancada.n)
		{
			Hotdde("VIg1b2",double_a_string(PF->fact_certainty));
		}
		else
		if (PF->result.n == VOsi_tancada.n)
		{
			Hotdde("VOsi",double_a_string(PF->fact_certainty));
		}
		else
		if (PF->result.n== VIsi_tancada.n)
		{
			Hotdde("VIsi",double_a_string(PF->fact_certainty));
		}
		else
		if (PF->result.n== VOrp_tancada.n)
		{
			Hotdde("VOrp",double_a_string(PF->fact_certainty));
		}
		else
		if (PF->result.n== VIrp_tancada.n)
		{
			Hotdde("VIrp",double_a_string(PF->fact_certainty));
		}
		else
		if (PF->result.n== VOpi_tancada.n)
		{
			Hotdde("VOpi",double_a_string(PF->fact_certainty));
		}
		else
		if (PF->result.n== VIpi_tancada.n)
		{
			Hotdde("VIpi",double_a_string(PF->fact_certainty));
		}
		else
		if (PF->result.n== VBPrp_tancada.n)
		{
			Hotdde("VBPrp",double_a_string(PF->fact_certainty));
		}
	}
EndForAll

EndSystem


/////////////////////////////////////////////
//////////      CEES  Main       ////////////
/////////////////////////////////////////////
void CEESmain()
{
printf("______________________________________________________");
printf("Tick = %d",TICK);

printf("%s",hora);
TICK++;

//- Mostrem els valors del DDE per pantalla
if (visual) mostrar_valors();

printf("");
printf("______________________ Motor d'inferencia PRIMARI __________________");

primari.name = 1;
primari.engine();

printf("");
printf("______________________ Motor d'inferencia SECUNDARI __________________");

secundari.name = 2;
secundari.engine();

printf("");
printf("______________________ Motor d'inferencia DIAGNOSTIC __________________");

diagnostic.name = 3;
diagnostic.engine();

printf("");
printf("______________________ Motor d'inferencia ACTIONS __________________");
accions.name = 4;
accions.engine();
}
